"use strict";

exports.__esModule = true;
exports.default = jsDocHandler;

var Doclets = _interopRequireWildcard(require("./doclets"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function jsDocHandler(documentation) {
  const description = documentation.get('description') || '';
  const displayName = documentation.get('displayName');
  const tags = Doclets.parseTags(description);
  const displayNameTag = tags.find(t => t.name === 'displayName');
  documentation.set('name', displayName);

  if (displayNameTag) {
    documentation.set('displayName', displayNameTag.value || displayName);
  }

  documentation.set('docblock', description);
  documentation.set('description', Doclets.cleanTags(description));
  documentation.set('tags', tags || []); // eslint-disable-next-line no-underscore-dangle

  documentation._props.forEach((_, name) => {
    const propDoc = documentation.getPropDescriptor(name);
    const propDescription = propDoc.description || '';
    const propTags = Doclets.parseTags(propDescription);
    propDoc.docblock = propDescription;
    propDoc.description = Doclets.cleanTags(propDescription);
    propDoc.tags = propTags || [];
    Doclets.applyPropTags(propDoc);
  });
}