/// <reference types="react" />
import { Prop } from '../types';
import { TokenMap } from './TypescriptTypeValue';
export interface RenderPropsOptions {
    tokenMap?: TokenMap;
    elementTypes?: Array<string | RegExp>;
}
export default function renderProps(propsData: Prop[], { tokenMap, elementTypes, }?: RenderPropsOptions): {
    name: string;
    tags: import("../types").Doclet[];
    typeName: string | undefined;
    description: JSX.Element;
    deprecated: string | undefined;
    type: JSX.Element | null;
    defaultValue: JSX.Element | undefined;
    propData: Prop;
}[];
