"use strict";

exports.__esModule = true;
exports.docletsToMap = docletsToMap;
exports.getDisplayTypeName = getDisplayTypeName;
exports.getDoclet = getDoclet;
exports.getTypeName = getTypeName;
exports.joinElements = joinElements;

var _react = _interopRequireDefault(require("react"));

var _doclets = require("./doclets");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function docletsToMap(doclets) {
  return new Map(doclets.map(({
    name,
    value
  }) => [name, value]));
}

function getDoclet(doclets = [], name) {
  const doc = doclets.find(d => d.name === name);
  return doc && doc.value;
}

function getDisplayTypeName(typeName) {
  if (typeName === 'func') return 'function';
  if (typeName === 'bool') return 'boolean';
  return typeName;
}

function getTypeName(prop) {
  const {
    type
  } = prop;
  const name = getDisplayTypeName(type == null ? void 0 : type.name);
  if (name === 'custom') return (0, _doclets.cleanDocletValue)(getDoclet(prop.tags, 'type') || type.raw);
  return name;
}

function joinElements(arr, delim, fn) {
  return arr.reduce((acc, val, idx, list) => {
    let item = fn(val, idx);

    if ( /*#__PURE__*/_react.default.isValidElement(item)) {
      // eslint-disable-next-line react/no-array-index-key
      item = /*#__PURE__*/_react.default.cloneElement(item, {
        key: idx
      });
    } // eslint-disable-next-line no-param-reassign


    acc = acc.concat(item);
    return idx === list.length - 1 ? acc : acc.concat(delim);
  }, []);
}